package com.lantone.structure.facade.tran;

import com.lantone.common.util.StringUtil;
import com.lantone.structure.model.doc.DailyCourseRecordDoc;
import com.lantone.structure.model.label.DailyCourseRecordLabel;
import lombok.extern.slf4j.Slf4j;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @Description:日常病程记录
 * @author: cy
 * @time: 2021/3/16 17:23
 */
@Slf4j
public class DailyCourseRecordTran extends TargetTran {

    @Override
    public Map<String, String> convert(String text) {
        List<DailyCourseRecordDoc> dailyCourseRecordDocs = new ArrayList<>();
        DailyCourseRecordDoc dailyCourseRecordDoc  = new DailyCourseRecordDoc();
        dailyCourseRecordDoc.setText(text);
        dailyCourseRecordDocs.add(dailyCourseRecordDoc);
        inputInfo.setDailyCourseRecordDocs(dailyCourseRecordDocs);
        Map<String, String> structureMap = new HashMap<String, String>();
        dailyCourseContrast(inputInfo.getDailyCourseRecordDocs(), structureMap);
        dailyCourseRecordDoc.setStructureMap(structureMap);
        aiProcess();
        lastSovle(inputInfo.getDailyCourseRecordDocs(),structureMap);
        return structureMap;
    }

    public void dailyCourseContrast(List<DailyCourseRecordDoc> dailyCourseRecordDocs,Map<String, String> retMap) {
        String text = dailyCourseRecordDocs.get(0).getText();
        String file = text;
        String[] split = file.split("\n");

        String str = extractDate(file);
            if(StringUtil.isNotEmpty(str)){
                retMap.put("记录日期时间",str);
        }

        String signDate = "签名日期";
        if(file.contains("签字日期")){
            signDate = "签字日期";
        }
        if(file.contains(signDate)){
            String date = file.substring(file.lastIndexOf(signDate));
            date = extractDate(date);
            if(StringUtil.isNotEmpty(date)){
                retMap.put("签名日期时间",date);
            }
        }
        String signName= parseString(file);
        if(StringUtil.isNotEmpty(signName) && StringUtil.isNotEmpty(signName.trim()) && signName.length()<15){
            retMap.put("医师签名",signName);
        }

        if( split.length>1){
            String ret = text.substring(text.lastIndexOf(split[1]) + split[1].length());
            if(StringUtil.isNotEmpty(retMap.get("医师签名")) && ret.contains(retMap.get("医师签名"))){
                ret = ret.substring(0, ret.lastIndexOf(retMap.get("医师签名")));
            }
            String falg  = "/";
            if(ret.endsWith("//")){
                falg = "//";
            }
            if(ret.endsWith(falg)){
                ret =  ret.substring(0,ret.lastIndexOf(falg));
            }
            if(StringUtil.isNotEmpty(ret)){
                retMap.put("住院病程",ret);
            }
        }
    }

    public static void lastSovle(List<DailyCourseRecordDoc> dailyCourseRecordDocs , Map<String,String> rep) {
        if(!dailyCourseRecordDocs.isEmpty() && dailyCourseRecordDocs.get(0)!=null && dailyCourseRecordDocs.get(0)
                .getDailyCourseRecordLabel()!=null){
            DailyCourseRecordLabel dailyCourseRecordLabel = dailyCourseRecordDocs.get(0).getDailyCourseRecordLabel();
            String doctorAdviceRecord = dailyCourseRecordLabel.getDoctorAdviceRecord();
            if(StringUtil.isNotEmpty(doctorAdviceRecord)){
                rep.put("医嘱内容",doctorAdviceRecord);
            }
        }
    }


    /**
     * 抽取文本中的第一个时间
     *
     * @param top
     * @return
     */
    public static String extractDate (String top){
        Pattern pattern = Pattern.compile("[0-9]{4}[-][0-9]{1,2}[-][0-9]{1,2}");
        Matcher matcher = pattern.matcher(top);
        if (matcher.find()) {
            return matcher.group(0);
        } else {
            Pattern p1 = Pattern.compile("[0-9]{4}年[0-9]+月[0-9]+日");
            Matcher m1 = p1.matcher(top);
            if (m1.find()) {
                return m1.group(0);
            }
        }
        return null;
    }

    // 取/后
    public static String parseString(String text){
        if(text.contains("/")){
            text = text.substring(text.lastIndexOf("/")+1);
            text= parseString(text);
        }
        return text;
    }

    // 取/前
    public static String parseStr(String text){
        if(text.contains("/")){
            text = text.substring(0,text.lastIndexOf("/"));
            text= parseStr(text);
        }
        return text;
    }
}